#!/usr/bin/perl

##################################################################
# adm12.pl : maintenance groupe - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if (!$in{grp}){
	&confirm('<H1><hr>Maintenance de groupe : probl&#232;me<hr></H1><H2>Aucun groupe choisi...</H2>');
}
if (!$in{sup_usr} && !$in{sup_resp} && !$in{sup_grp} && !$in{vid_rep}){
	&confirm('<H1><hr>Maintenance de groupe : probl&#232;me<hr></H1><H2>Aucune action choisie...</H2>');
}

#--- date pour repertoire de sauvegarde
if ($in{sav_rep}){
	@date=gmtime(time());
	$save_the_date = join('-',($date[3],$date[4]++,1900 + $date[5])).'_'. join('-',($date[2],$date[1],$date[0]));
}


#--- membres du group
@membres = &memb_grp('grp_'.$in{grp},'t');

#--- supprime (passwd et group) les utilisateurs de ce seul groupe  et leurs repertoires (perso, profil)
if ($in{sup_usr}){
	# liste tous les utilisateurs
	@groups = &list_grp;
	foreach $the_grp (@groups){
		next if ($the_grp eq $in{grp});
		%pp = &memb_grp('grp_'.$the_grp,'h');
		%membre_autres = (%membre_autres,&memb_grp($the_grp,'h'));
	}
	# liste les responsables
	%respons = &memb_grp('resp','h');
	# membres du groupe (sans les responsables et pas ceux dans les autres groupes)
	foreach $memb (@membres){
		# il est responsable, on le laisse membre
		next if ($respons{$memb});
		# il n'est pas responsable, on le supprime du groupe (/etc/group)
		&mod_usr_grp($memb,'grp_'.$in{grp},'sup');
		# il est membre autre groupe, on ne supprime rien d'autre
		next if ($membre_autres{$memb});
		# sauvegarde des donnes si demand
		$result_save = &cp_rep($memb) if ($in{sav_rep});
		push(@resume_save,$result_save);
		# suppression de son login (/etc/passwd)
		&mod_passwd($memb,'x','x','sup');
		# suppression rep perso
		&del_rep('/home/minal2/rep/'.$memb);
		# suppression rep profil
		&del_rep('/home/minal2/profil/'.$memb);
        }
}

# enleve tous les responsables du groupe
if ($in{sup_resp}){
	# liste les responsables
	@respons = &memb_grp('resp_'.$in{grp},'t');
	foreach $the_resp (@respons){
		&mod_usr_grp($the_resp,'resp_'.$in{grp},'sup');
	}
}



#--- vide le repertoire si pas suppr du groupe
if ($in{vid_rep} && !$in{sup_grp}) {
	# sauvegarde des donnes si demand
	$result_save = &cp_rep($in{grp}) if ($in{sav_rep});
	push(@resume_save,$result_save);
	# suppression repertoire
	&del_rep('/home/minal2/rep/'.$in{grp});
	# recreation
	$rep_grp = &untunt_fic('/home/minal2/rep/'.$in{grp});
	($nom,$pwg,$gid,$membos) = &trouve('grp_'.$in{grp},1,':',$fic_grp);
	$gid_grp = &untunt_fic($gid);
	mkdir($rep_grp,0770);
	chown('10000',$gid_grp,$rep_grp);
	chmod(0770,$rep_grp);
}

#--- supprime groupe dans /etc/group + repertoire
if ($in{sup_grp}){
	# sauvegarde des donnes si demand
	$result_save = &cp_rep($in{grp}) if ($in{sav_rep});
	push(@resume_save,$result_save);
	# suppresion du groupe et du rep
	@membre_grp = &mod_group($in{grp},'sup');
}

#--- affichage
$info .= '<CENTER><hr><H1>Maintenance d\'un groupe d\'utilisateurs</H1><hr></CENTER><BR>'."\n";
$info .= 'L\'opration s\'est correctement droule<br>'."\n";
if ($in{sav_rep}){
	$info .= '<br>Rsultats de la sauvegarde : <ul><li> rpertoire de sauvegardes sur le serveur <b>'.$rep_save_base.'/</b>'."\n";
	foreach(@resume_save){
		($fic_org,$fic_cp,$rep_org,$rep_cp,$taille) = split('',$_);
		$taille_tot += $taille;
		$fic_cp_tot += $fic_cp;
	}
	$info .= '<li> nombre de fichiers sauvegardes :  <b>'.$fic_cp_tot.'</b>'."\n";
	$info .= '<li> place occupe par cette sauvegarde :  <b>'.$taille_tot.'</b> octets'."\n";
	$info .= '</ul>'."\n";
}
$info .= 'Effectuer une maintenance sur un <a href="./adm11.pl">autre groupe</a>'."\n";

#--- envoi
&confirm($info);



