#!/usr/bin/perl

#################################################################
# install.pl : installation - Projet MINAL2.1
#################################################################


# configuration installation
$fic_conf_apache = '/etc/httpd/conf/commonhttpd.conf';	# mandrake 8.0 8.1 8.2 9.0
# $fic_conf_apache = '/etc/httpd/conf/httpd.conf';	# mandrake 7
$fic_conf_dhcpd = '/etc/dhcpd.conf';			# toutes versions
$fic_smb = '/etc/samba/smb.conf';			# mandrake 8.1 8.2 9.0
# $fic_smb = '/etc/smb.conf';				# mandrake 7 8.0
$ip_base = '192.168.0';



#################################################################
# ne pas changer les lignes en dessous
#################################################################

#--- repertoires
$rep_adm = '/adm';
$rep_cgi = '/cgi';

#--- fichier configuration apache
$fic_loc = $fic_conf_apache;
@tab = &ouvre($fic_loc) if (!-e $fic_loc.'_org_minal2');
@tab = &ouvre($fic_loc.'_org_minal2') if (-e $fic_loc.'_org_minal2');
# sauvegarde ancien si n'existe pas
&maj_bdd($fic_loc.'_org_minal2',@tab) if (!-e $fic_loc.'_org_minal2');
# recup chemin DocumentRoot
foreach(@tab){
	# deja installe ?
	if (/MINAL 2/){
		$deja_inst = 1;
		last;
	}
	if (/^DocumentRoot/){
		$doc_root = $_;
		$doc_root =~ s/DocumentRoot //;
	}
	s/^LanguagePriority/\#LanguagePriority/;
}
if(!-d $doc_root){
	&avert("Probleme... le repertoire de base du serveur web ($doc_root) n'existe pas..\nVerifiez si le serveur Apache est bien install")
}
# pas deja installe
if(!$deja_inst){
	@tab2 = &ouvre('./httpd');
	foreach(@tab2){
		s/<doc_root>/$doc_root/g;
		s/<rep_adm>/$rep_adm/g;
		s/<rep_cgi>/$rep_cgi/g;
	}
	push(@tab,@tab2);
	&maj_bdd($fic_loc,@tab);
}

#--- fichier dhcpd
$fic_loc = $fic_conf_dhcpd;
# sauvegarde ancien si n'existe pas
&copie($fic_loc,$fic_loc.'_org_minal2') if (!-e $fic_loc.'_org_minal2');
# nouveau
@tab2 = &ouvre('./dhcpd');
foreach(@tab2){
	s/<ip_base>/$ip_base/g;
}
&maj_bdd($fic_loc,@tab2);


#--- fichier smb.conf
$fic_loc = $fic_smb;
# sauvegarde ancien si n'existe pas
&copie($fic_loc,$fic_loc.'_org_minal2') if (!-e $fic_loc.'_org_minal2');
# nouveau
@tab2 = &ouvre('./samba');
foreach(@tab2){
	s/<ip_base>/$ip_base/g;
}
&maj_bdd($fic_loc,@tab2);



#---rep netlogon
$rep = '/home/netlogon';
mkdir($rep,0755) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0755,$rep);
# demar.bat
&copie('./demar.bat','/home/netlogon/demar.bat') if (!-e '/home/netlogon/demar.bat');
chown('10000','10000','/home/netlogon/demar.bat');
chmod(0644,'/home/netlogon/demar.bat');

# strat.pol
&copie('./strat.pol','/home/netlogon/strat.pol') if (!-e '/home/netlogon/strat.pol');
chown('10000','10000','/home/netlogon/strat.pol');
chmod(0644,'/home/netlogon/strat.pol');	


#---copie des fichiers et rpertoires et droits
# adm
$rep = $doc_root.$rep_adm;
mkdir($rep,0777) if (!-e $rep);
chmod(0777,$rep);
@fic = &lirep('../adm');
foreach(@fic){
	$nom_fic = $_;
	$nom_fic =~ s/\.\.\/adm//;
	&copie($_,$doc_root.$rep_adm.$nom_fic);
	chmod(0666,$doc_root.$rep_adm.$nom_fic);
}


# cgi
$rep = $doc_root.$rep_cgi;
mkdir($rep,0755) if (!-e $rep);
chmod(0755,$rep);
@fic = &lirep('../cgi');
foreach(@fic){
	$nom_fic = $_;
	$nom_fic =~ s/\.\.\/cgi//;
	&copie($_,$doc_root.$rep_cgi.$nom_fic);
	chmod(0755,$doc_root.$rep_cgi.$nom_fic);
}
# droits tendus du root
chown(0,0,$doc_root.$rep_cgi.'/adm2.pl',$doc_root.$rep_cgi.'/adm5.pl',$doc_root.$rep_cgi.'/adm6.pl',$doc_root.$rep_cgi.'/adm8.pl',$doc_root.$rep_cgi.'/adm10.pl',$doc_root.$rep_cgi.'/adm12.pl',$doc_root.$rep_cgi.'/adm16.pl',$doc_root.$rep_cgi.'/adm18.pl',$doc_root.$rep_cgi.'/adm19.pl',$doc_root.$rep_cgi.'/adm21.pl',$doc_root.$rep_cgi.'/adm23.pl');
chmod(04755,$doc_root.$rep_cgi.'/adm2.pl',$doc_root.$rep_cgi.'/adm5.pl',$doc_root.$rep_cgi.'/adm6.pl',$doc_root.$rep_cgi.'/adm8.pl',$doc_root.$rep_cgi.'/adm10.pl',$doc_root.$rep_cgi.'/adm12.pl',$doc_root.$rep_cgi.'/adm16.pl',$doc_root.$rep_cgi.'/adm18.pl',$doc_root.$rep_cgi.'/adm19.pl',$doc_root.$rep_cgi.'/adm21.pl',$doc_root.$rep_cgi.'/adm23.pl');
chown(0,0,$doc_root.$rep_cgi.'/resp2.pl',$doc_root.$rep_cgi.'/resp5.pl',$doc_root.$rep_cgi.'/resp6.pl',$doc_root.$rep_cgi.'/resp8.pl',$doc_root.$rep_cgi.'/resp10.pl',$doc_root.$rep_cgi.'/resp12.pl');
chmod(04755,$doc_root.$rep_cgi.'/resp2.pl',$doc_root.$rep_cgi.'/resp5.pl',$doc_root.$rep_cgi.'/resp6.pl',$doc_root.$rep_cgi.'/resp8.pl',$doc_root.$rep_cgi.'/resp10.pl',$doc_root.$rep_cgi.'/resp12.pl');
chown(0,0,$doc_root.$rep_cgi.'/usr2.pl');
chmod(04755,$doc_root.$rep_cgi.'/usr2.pl');

# fichier de configuration cfg
$fic_loc = './cfg';
@tab = &ouvre($fic_loc);
foreach(@tab){
	s/<doc_root>/$doc_root/g;
	s/<rep_adm>/$rep_adm/g;
	s/<rep_cgi>/$rep_cgi/g;
}
&maj_bdd($doc_root.$rep_cgi.'/minal2.cfg',@tab);
chmod(0644,$doc_root.$rep_cgi.'/minal2.cfg');	


# img
$rep = $doc_root.'/img';
mkdir($rep,0755) if (!-e $rep);
chmod(0755,$rep);
@fic = &lirep('../img');
foreach(@fic){
	$nom_fic = $_;
	$nom_fic =~ s/\.\.//;
	&copie($_,$doc_root.$nom_fic);
	chmod(0644,$doc_root.$nom_fic);	
}

#--- page accueil
&copie('./minal2.htm',$doc_root.'/minal2.htm') if (!-e $doc_root.'/minal2.htm');
chmod(0644,$doc_root.'/minal2.htm');	

#--- repertoire /home/minal2
$rep = '/home/minal2';
mkdir($rep,0755) if (!-e $rep);
chmod(0755,$rep);

#---rep document
$rep = '/home/minal2/document';
mkdir($rep,0775) if (!-e $rep);
chown('10000','10001',$rep);
chmod(0775,$rep);

#---rep save
$rep = '/home/minal2/save';
mkdir($rep,0777) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0777,$rep);


#--- repertoire /home/appli
$rep = '/home/appli';
mkdir($rep,0755) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0755,$rep);

#--- repertoire des repertoires persos et groupes
$rep = '/home/minal2/rep';
mkdir($rep,0755) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0755,$rep);


#--- repertoire des repertoires profils
$rep = '/home/minal2/profil';
mkdir($rep,0755) if (!-e $rep);
chmod(0755,$rep);
chown('10000','10000',$rep);
chmod(0770,$rep);
$rep = '/home/minal2/profil/admin';
mkdir($rep,0770) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0770,$rep);

#--- repertoire utilitaires
$rep = '/home/minal2/util';
mkdir($rep,0755) if (!-e $rep);
chown('10000','10000',$rep);
chmod(0755,$rep);

print "\n\n";
print "-----------------------------\n";
print "---------- MINAL 2 ----------\n";
print "-----------------------------\n\n";
print "Installation terminee\n\n";
print 'Repertoire de base du serveur web : '.$doc_root."\n";
print 'Page d\'accueil : http://'.$ip_base.'.254/minal2.htm'."\n\n";
print 'Rebootez la machine, c\'est pret...'."\n\n";
print "-----------------------------\n\n";
exit;

###############################################################################################
############################################  S U B  ##########################################
###############################################################################################

#--- sub d'ouverture fichier
sub ouvre {
	$fichier = $_[0];
	@fic_ouvre = @nul;
	if (-e $fichier){
		open(FICHIER,$fichier) || &avert("Pb pour ouvrir fichier $fichier...");
		while (<FICHIER>) {
			chomp;
			push (@fic_ouvre,$_);
		}
		close FICHIER || &avert("Pb pour fermer fichier $fichier...");
	}
	return @fic_ouvre;
}

#--- sub de creation de fichier si pas existant
sub makif {
	$fichier = $_[0];
	if (!(-e $fichier)){
		open(FICHIER,">$fichier") || &avert("Pb pour crer fichier $fichier...");
		close FICHIER || &avert("Pb pour fermer fichier $fichier...");
        	chmod(0666, "$fichier");
        	return 1;
	} else {
		return 0;
	}
}


#--- sub d'untuntain de fichier transmis
sub untunt_fic{
	$nom_fichier = $_[0];
	$nom_fichier =~ s/^\///;
	@rept = split(/\//,$nom_fichier);
	@repertoire = @nul;
	foreach(@rept){
		if (/^([-\@\w.]+)$/) {
			push(@repertoire,$1);
		} else {
			&avert('<H1>Probleme</H1><H2>Nom de fichier ne permettant pas d\'effectuer une opration sur le fichier '.$_[0].'</H2>');
		}
	}
	$fichier_final = join('/',@repertoire);
	$fichier_final =~ s/^/\// if ($_[0] =~ /^\//);
	return $fichier_final;
}

#--- sub d'avertissement en fonction du destinataire
sub avert {
	print "$_[0]\n\n";	# message a afficher
}


#--- maj fichier bd
sub maj_bdd{
	($fichier,@tableau) = @_;
	open(FICHIER,">$fichier") || &avert("Pb pour mettre a jour fichier $fichier...");
	foreach (@tableau) {
		print FICHIER "$_\n";
	}
	close FICHIER || &avert("Pb pour fermer fichier $fichier..");
}


#--- mise au point
sub map{
	foreach(@_){
		$mapin .= '--'.$_.'<br>';
	}
	&avert('Mise au point...<br>'.$mapin);
}


#--- lecture du contenu d'un repertoire
sub lirep {
	opendir(DIR,$_[0]);
	@fichiers_repertoires = map{m/^\.+$/ ? () : "$_[0]/$_"} readdir(DIR);
	closedir(DIR);
	return @fichiers_repertoires;
}

#--- copie de fichier (pb link certaines config)
sub copie {
	@fic_src = &ouvre($_[0]);
	&maj_bdd($_[1],@fic_src);
}






